<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.menu');

class plgBill_gatewaysPaywebmoney extends JPlugin
{

	var $_db = null;
	function plgBill_gatewaysPaywebmoney(& $subject, $config)
	{
		$this->_db = JFactory :: getDBO();
		parent :: __construct($subject, $config);
	}
	function onReceivePayment(&$post)
	{

		if($post['processor'] != 'paywebmoney') return array();
		if($post['pay'] != 'notify') return array();
		
		$sql = "SELECT ud.params FROM #__jc_users AS ud " . 
					"INNER JOIN #__bills_invoice AS bi ON bi.seller_id = ud.user_id " .
					"INNER JOIN #__jc_orders AS o ON o.id = bi.order_num " .
					"WHERE bi.id = {$post['order_id']} && bi.client = 'Mighty Commerce' AND ud.section_id = o.section_id " . 
					"LIMIT 1";
					
		$this->_db->setQuery($sql);
		$param_res = $this->_db->loadResult();
		if ( $param_res )
		{
		  //get vendor params
		  $default_params = new JParameter($param_res);
		}
		else
		{
		  // params will take from plugin manager
		  $default_params = $this->params;
		}
		
		$params = new JParameter($post['params']);

		$key = $post['LMI_PAYEE_PURSE'];
		$key .= $post['LMI_PAYMENT_AMOUNT'];
		$key .= $post['LMI_PAYMENT_NO'];
		$key .= $post['LMI_MODE'];
		$key .= $post['LMI_SYS_INVS_NO'];
		$key .= $post['LMI_SYS_TRANS_NO'];
		$key .= $post['LMI_SYS_TRANS_DATE'];
		$key .= $params->get("paywebmoney_secret", $default_params->get("paywebmoney_secret"));
		$key .= $post['LMI_PAYER_PURSE'];
		$key .= $post['LMI_PAYER_WM'];
		
		$key = md5($key);

		//error_log(print_r($post, true)."\nkey: ".$key, 3, JPATH_CACHE.DS.'log.txt');
		
		if ( $key == strtolower($post['LMI_HASH']) )
		{
			$out['pay'] = 'success';
		}
		else
		{
			$out['pay'] = 'fail';
		}
		
		$out['sid']      = $post['LMI_PAYMENT_NO'];
		$out['gateway']  = $post['processor'];
		$out['gateway_id'] = $post["LMI_SYS_TRANS_NO"];
		$out['user_id']    = $post["USER_ID"];
		$out['price']    = $post["LMI_PAYMENT_AMOUNT"];
		$out['email']    = $post['EMAIL'];
		
		if(class_exists('Bill')) $out['key']  = strtoupper(md5(Bill::getSecretWord().$out['user_id'].$out['gateway_id'].$out['price'].$out['sid']));

		return $out;
	}

	function onSendPayment(&$post)
	{

		if($post['processor'] != 'paywebmoney') return FALSE;

		$Itemid				= JRequest::getInt('Itemid');
		$default_params 	= $this->params;
		$params 			= new JParameter( $post['params'] );
		$order_number		= (int)@$post['order_id'];
		$shop_uri 			= JURI::root();
		$url 				= "https://merchant.webmoney.ru/lmi/payment.asp?";
		$payee_purse		= $params->get("paywebmoney_purse", $default_params->get("paywebmoney_purse"));
		$payment_description= htmlspecialchars(iconv("UTF-8", "cp1251", $post['order_title']));
		$scale 				= floatval($params->get("paywebmoney_scale", $default_params->get("paywebmoney_scale")));
		if($scale <= 0) $scale = 1;
		$total_sum_to_pay  	= round(floatval($post['order_amount']) * $scale, 2);

		$user = &JFactory::getUser();

		$param['option'] = 'com_jsbill';
		$param['task']   = 'create';
		$param['view']   = 'bill';
		//$param['layout'] = @$post['layout'];
		$param['processor'] = @$post['processor'];
		$param['order_id']  = $order_number;
		$param['amount']    = $total_sum_to_pay;

		//$success		= JURI::root()."index.php?option=".$param["option"]."&task=".$param["task"]."&processor=paywebmoney&pay=success&view=".$param["view"]."&layout=".$param["layout"];
		//$cancel_return	= JURI::root()."index.php?option=".$param["option"]."&task=".$param["task"]."&processor=paywebmoney&pay=fail&view=".$param["view"]."&layout=".$param["layout"];

		$result_url 	= JURI::root().'index.php?'.$this->WMArray2Url($param).'&pay=notify';
		$success_url	= JURI::root().'index.php?option='.$param['option'].'&view='.$param['view'].'&layout=history&Itemid='.$Itemid;
		$fail_url  		= JURI::root().'index.php?option='.$param['option'].'&view='.$param['view'].'&layout=history&Itemid='.$Itemid;
			
		$post_variables = Array(
			"LMI_RESULT_URL" 	=> $result_url,    
			"LMI_PAYMENT_AMOUNT" => $total_sum_to_pay,    
			"LMI_PAYMENT_DESC" 	=> $payment_description,
			"LMI_PAYMENT_NO" 	=> $order_number,  
			"LMI_PAYEE_PURSE" 	=> $payee_purse,
			"LMI_SUCCESS_URL" 	=> $success_url,
			"LMI_SUCCESS_METHOD"=> "2",
			"LMI_FAIL_URL" 		=> $fail_url,
			"LMI_FAIL_METHOD" 	=> "2",
			"LMI_MODE"			=> $params->get("paywebmoney_demo", $default_params->get("paywebmoney_demo", 1)),
			"LMI_SIM_MODE" 		=> "0",
			"PRICE"				=> $total_sum_to_pay,
			"USER_ID"			=> $user->get("id"),
			"EMAIL"				=> $user->get("email")
		);
		
		//echo $result_url;

		JHTML::_( 'behavior.modal' );
		$c  = '<div style="padding:10px;text-align:center;">';
		$c .= '<h3>'.JText::_('Order Is Formed').'</h3><br />'; // Please remember to activate WebMoney Keeper prior to processing next step
		$c .= '<img border="0" src="http://www.webmoney.ru/img/banner/AWM'.$params->get("paywebmoney_img", $default_params->get("paywebmoney_img", 'grey')).'_eng.gif" /><br /><br />';
		$c .= '<form action="'.$url.'" method="post">';
		$c .= '<input type="submit" value="'.JText::_('Continue >>>').'" name="formSubmit" class="button"/>';
		foreach( $post_variables as $name => $value )
			$c .= '<input type="hidden" name="'.$name.'" value="'.$value.'" />';
		$c .= '</form>';
		$c .= '</div>';
		?>
		<script>
			window.addEvent("domready",	function(){	SqueezeBox.initialize({size: {x: 200, y: 150}});
			SqueezeBox.applyContent('<?php echo $c?>',{x:200,y:150}); });
		</script>
		<?php
	}
	function WMArray2Url($param)
	{
		foreach($param AS $k => $v)
		{
			$out[] = "$k=$v";
		}
		return implode('&', $out );
	}
}



?>